-- search for -- UP TO HERE

--  version 1.1
--  some modifications over the prime focus version, esp. the camera prefix

global RPMDataVersion = 0.01; -- edit value in main attribute definition
global SMTD_MainRollout
global SMTDSettings, SMTDFunctions, SMTDSettings_copy
global SMTD_PerformSanityCheck
global SMTD_UserDefinedTilesDialog
global SMTD_UserDefinedTilesBitmap
global SMTD_UserDefinedTilesBitmapDisplay = bitmap 400 300
global SMTD_BlackListSlaves, SMTD_ShowSlaveInfo, SMTD_TilesRendering
global SMTD_objsToBake
global SMTD_PassDependencies
global SMTD_MainRollout_MainMenu

struct RPMDeadline6DataStruct
(
	-- make the rollout(s) visible externally
	Deadline6Rollout,
	Deadline6SubRolloutItems,
	JustPassArrayOfPassesToCustomSubmission,
	lastRestoredPass,
	UpdatingDeadlineUI = false,
	DebugPrint = false  -- if you remove this, check for it below as many functions use it.

,
	function getIDfromMessage renderMsg =
	(
		retreivedID = "failed"
		theStringStream = renderMsg as stringStream
		skipToString theStringStream "JobID="
		try(retreivedID = readline theStringStream)catch()
		return retreivedID
	)
,
	function submitDeadline6Render passIndex cameraSuffix: =
	(
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do print "{info} submitDeadline6Render"
		--return result;

		-- restore data
		RPMDataNet.CustomSubmitStruct.RestoreDeadline6Data passIndex wherefrom:1

		-- set job name
		if SMTDSettings.JobName != "$outputfilename" do
		(
			try(

				if (RPMdata.GetShotPrefix()) == "" then
					SMTDSettings.JobName = rpmdata.getpassname passIndex quiet:true
				else
					SMTDSettings.JobName = RPMdata.GetShotPrefix() + " - " + rpmdata.getpassname passIndex quiet:true

				if cameraSuffix != unsupplied do
					SMTDSettings.JobName += cameraSuffix
			)catch()
		)
		-- set job user, since this defaults to the sysinfo.user not SMTDFunctions.GetDeadlineUser()
		-- only do if it is at the default.s
		--if (SMTDSettings.username  == sysinfo.username) do
		SMTDSettings.username = SMTDFunctions.GetDeadlineUser();

		-- submit - this code comes from the frantic submit script
		--Ui_report ">SUBMIT Button Pressed."
		local result = undefined
		local sanity = true







		--if sanity do
		(
			--reportSubmissionSettings()
			
			-- if this is the first pass being submitted, clear the job list:
			
			
			if (passIndex == rpmrendsubmit.origsortedsubmitarray[1]) do 
			(
				--print "Clearing submitted job ID array, storing in 10003" -- storing just in case it's useful,each item has the submitted job id and the unique ID of the RPM pass
				if rpmdata.getcustglobstorage 10002 != undefined do
				(
					rpmdata.setcustglobstorage 10003 (rpmdata.buildappdata (rpmdata.getcustglobstorage 10002))
				)
				rpmdata.setcustglobstorage 10002 (rpmdata.buildappdata #())
			)
			
			local theMessage = SMTDFunctions.SubmitJobFromUI()
			submittedJobs = rpmdata.getcustglobstorage 10002
			if submittedJobs == undefined do submittedJobs = #()
			
			-- we collect the submitted job id and store
			append submittedJobs #( (getIDfromMessage theMessage), rpmdata.getuniquefromindex passIndex)
			rpmdata.setcustglobstorage 10002 (rpmdata.buildappdata submittedJobs)
			

			RPMdata.addToFeedback "" theMessage "Return" 0

			--print (rpmdata.getcustglobstorage 10002)
			
			if (rpmrendsubmit.sortedsubmitarray.count == 0) do -- clear this out if this is the last pass so it's rebuild for the next submission. Will be fixed in RPM later on, 
			(
				--print "clearing origsortedsubmitarray"
				rpmrendsubmit.origsortedsubmitarray = undefined
			)

			return theMessage;
		)
	)
,

--- functions moved into here;
	fn getSafeData data type vdefault =
	(
			-- if the data is of the wrong class (ie out of range index) then this sets the value and returns the default
			case type of
			(
				#string: if classof data != string do (data = vdefault; return vdefault)
				#float: if classof data != float do (data = vdefault; return vdefault)
				#integer: if classof data != integer do (data = vdefault; return vdefault)
				#boolean: if classof data != booleanclass do (data = vdefault; return vdefault)
				#name: if classof data != name do (data = vdefault; return vdefault)
			)
			data -- just feed it back
	)
,
	fn StoreAllDeadline6Data passIndex =
	(
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do print "{info} StoreAllDeadline6Data"
		local cPassData, numb
		if SMTDSettings == undefined do return();
		dlProps = getpropnames SMTDSettings
		local numb = rpmdata.rmgetstordata passIndex
		cPassData = #()
		for i in 1 to dlprops.count do
		(
			val = getproperty SMTDSettings dlProps[i]
			if classof val == string then
				if findstring val "\\" != undefined do
				(
					val = rpmdata.rmconvertpathdividers val
				)
			else if classof val == array then
			(
				val = rpmdata.buildappdata val
			)
			else if classof val == dotNetObject do
			(
				continue -- we don't support these as per pass settings...
			)
			append cPassData #(dlProps[i], val)
		)
		setappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb (RPMdata.buildappdata cPassData)
	)
	
	

,
	fn RestoreDeadline6Data passIndex wherefrom: =
	(
		
		if passIndex == lastRestoredPass do return(); -- already done...
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do print ("{info} RestoreDeadline6Data - " + wherefrom as string)
	 -- this should get both the propery list and the valueus from the storeage.
		local cPassData, numb
		if SMTDSettings == undefined do return();
		shared_slaves_count = SMTDSettings.Slaves.count
		shared_slaves = SMTDSettings.Slaves
		shared_pools_list = SMTDSettings.Pools
		shared_groups_list = SMTDSettings.Groups
		try(shared_networkroot = SMTDPaths.NetworkRoot)catch()
		try(
			--dlProps = getpropnames SMTDSettings
			local numb = rpmdata.rmgetstordata passIndex
			--try(
				cPassData = execute (getappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb)
			--)catch(print ("Deadline data failed to restore:" + getCurrentException()); return false)
			for i in cPassData do
			(
				if isproperty SMTDSettings  i[1] do
					setproperty SMTDSettings i[1] i[2]
			)

			SMTDSettings_copy = copy SMTDSettings
		) catch(
			StoreAllDeadline6Data passIndex
			--dlProps = getpropnames SMTDSettings
			local numb = rpmdata.rmgetstordata passIndex
			try(
				cPassData = execute (getappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb)
			)catch(print ("Deadline data failed to restore (2):" + getCurrentException()); return false)
			for i in cPassData do
			(
				if isproperty SMTDSettings  i[1] do
					setproperty SMTDSettings i[1] i[2]
			)

			SMTDSettings_copy = copy SMTDSettings
		)
		SMTDSettings.Slaves.count = shared_slaves_count 
		SMTDSettings.Slaves = shared_slaves
		SMTDSettings.Pools = shared_pools_list
		SMTDSettings.Groups = shared_groups_list
		try( SMTDPaths.NetworkRoot = shared_networkroot )catch()
		SMTDSettings_copy = copy SMTDSettings
		lastRestoredPass = passIndex
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do print "{info} ...RestoreDeadline6Data restored"
	)
,
	fn UpdateDeadline6Data passIndex propertyNames propertyValues =
	(
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do print "{info} UpdateDeadline6Data"
	 -- this should get both the propery list and the valueus from the storeage.
		local cPassData, numb
		if SMTDSettings == undefined do return();

		-- make a working copy of the stored data:
		local tempData = copy SMTDSettings
		--dlProps = getpropnames SMTDSettings
		local numb = rpmdata.rmgetstordata passIndex
		try(
			cPassData = execute (getappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb)
		)catch(print ("Deadline data failed to restore:" + getCurrentException()); return false)

		for i in cPassData do
		(
			if isproperty tempData  i[1] do
				setproperty tempData i[1] i[2]
		)
		for i in 1 to propertyNames.count do
			setproperty tempData propertyNames[i] propertyValues[i]
	-- now write the data out:
		local cPassData = #()
		local dlProps = getpropnames tempData
		for i in 1 to dlprops.count do
		(
			val = getproperty tempData dlProps[i]
			if classof val == string then
				if findstring val "\\" != undefined do
				(
					val = rpmdata.rmconvertpathdividers val
				)
			else if classof val == array do
			(
				val = rpmdata.buildappdata val
			)
			append cPassData #(dlProps[i], val)
		)
		setappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb (RPMdata.buildappdata cPassData)

	)
,
	fn SetDeadline6DataByNumb numb data =
	(
	 -- this should get both the propery list and the valueus from the storeage.
		local cPassData
		if SMTDSettings == undefined do return();
		setappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb (RPMdata.buildappdata data)
	)
,
	fn GetDeadline6DataByNumb numb =
	(
	 -- this should get both the propery list and the valueus from the storeage.
		local cPassData, numb
		if SMTDSettings == undefined do return();

		try(
			cPassData = execute (getappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb)
		)catch(print "Deadline data failed to restore"; return false)
		return cPassData
	)
,

	fn getDeadline6RPMData =
	(
		if SMTDSettings == undefined do return();

		if not(isproperty Trackviewnodes #RenderPassManager) do return (#())
		local opts = undefined;
		return opts;
	)
,
	fn StoreRolloutState =
	(
		if SMTDSettings == undefined do return();
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do print "{info} Deadline6 storerolloutstate called"

		-- storing of entire UI layout here

	)
,
	/*---------------------------------------------------------------------------------------------------------------------------------------------*/
	fn prepDataForSubmit passIndex makeDirs:true updateUI:false=
	(
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do print "{info} prepDataForSubmit"
		if updateUI do
		(
			StoreRolloutState()
		)
	)


,
	fn AddPass passIndex = -- this is the index in RPM's list
	(
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do
			 print "{info} RPM_addPass"
		StoreAllDeadline6Data passIndex;
		
		if passIndex == 1 do
			RPMDeadline6DataStruct.RPMloadDeadlineSettings()
		
		try(SMTD_PassDependencies.updatePassDisplay())catch()
	)
,
	fn DuplicatePass orignumb newnumb =
	(

		origData = GetDeadline6DataByNumb orignumb
		if origData == false then
		(
			-- store the current data
			StoreAllDeadline6Data (rpmdata.getindexfromunique newnumb)
		) else (
			origData = SetDeadline6DataByNumb newnumb origData
		)
		try(SMTD_PassDependencies.updatePassDisplay())catch()
	)
,

	fn DeletePass passIndex =
	(
		-- this is taken care of since the data storage is internal to RPM
		try(SMTD_PassDependencies.updatePassDisplay())catch()
	)
,
	fn submitJob passIndex cameraSuffix: =
	(
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do(
			print ("{info} submitJob called ")
			print ("{cameraSuffix}  " + cameraSuffix as string )
		)
		prepDataForSubmit passIndex;
		local retval = RPMDataNet.CustomSubmitStruct.submitDeadline6Render passIndex ui:false cameraSuffix:cameraSuffix;
	)
,
	fn submitBatch passArray cameraSuffix: =
	(
		-- if the JustPassArrayOfPassesToCustomSubmission is set to true, RPM will just pass an array of indices to this function rather than submitting each pass.
		-- It is up to you to submit them all, and make sure the RPM data is restored in each. Likely via a filepostload callback, with RPM installed on all slaves, calling
		-- RPMData.RMRestValues 1


		--print "Custom Submit Batch"
		--print #(passArray)
		for passIndex  in passarray do
		(
			-- append some persistent callbacks

			-- then save file

			-- then submit

			)
		RPMDataNet.CustomSubmitReturn =  #(#batchSubmit, "Done", 0)
	)
,
	fn ClearAllRPMData =
	(
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do
			 print "ClearAllRPMData called in CustomSubmitStruct"
		-- do cleanup here
	)
	,
	fn updateDeadline6UI passinfo =
	(
		-- Only update the UI if it's not already in the process of being updated (avoid infinite loops).
		if not UpdatingDeadlineUI then
		(
			if RPMDataNet.CustomSubmitStruct.DebugPrint == true do
				print "updateDeadline6UI"
			
			UpdatingDeadlineUI = true
			
			-- I'd prefer if this was calling a set of exposed update functions - need to talk to bobo
			-- for now this quick hack:
			if (RPMdata.isCurrentRollout #CustomSubmit) do
			(
				for i in rmpasses.subrollmain.rollouts do
					removesubrollout rmpasses.subrollmain i
				for i in rpmdata.RPMCustomSubmit do
					addsubrollout rmpasses.subrollmain i
			)
			
			UpdatingDeadlineUI = false
		)
	)
	,
	fn UpdateRollouts passIndexArray wherefrom: =
	(
		-- passindex is an array of passes iindicating which are selected. If just one, then just one pass is highlighted.
		
		if passIndex == lastRestoredPass do return(); -- already done... if this is an array then it won't match anyway
		
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do
			print ("{info} UpdateRollouts called in CustomSubmitStruct " + passIndexArray as string + " " + wherefrom as string)
		-- you could do the rollout updating here rather than using the restoreUI functions in each rollout
			try(
		RPMDataNet.CustomSubmitStruct.RestoreDeadline6Data passIndexArray[1] wherefrom:2; -- this needs to support mutliple one day, for now just use the first
		)catch()
		try(
			Deadline6Rollout.open = true
		)catch(print "Deadline6Rollout.open  undefined")
		try(
			updateDeadline6UI passIndexArray
		)catch(print "updateDeadline6UI() undefined")
		
		SMTD_MainRollout.open = false
		SMTD_MainRollout.open = true
	
	)
	,

	fn RestorePass passIndex isPreview:false =
	(
		if passIndex == lastRestoredPass do return(); -- already done...
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do
			print ("{info} RestorePass called ")
		-- passindex is an array of passes iindicating which are selected. If just one, then just one pass is highlighted.
		--print ("RestorePass called in CustomSubmitStruct " + passIndex as string)
		-- you could do the rollout updating here rather than using the restoreUI functions in each rollout

		RPMDataNet.CustomSubmitStruct.RestoreDeadline6Data passIndex wherefrom:3;
		updateDeadline6UI passIndex -- no passindex as it uses the global data only
		SMTD_MainRollout.open = false
		SMTD_MainRollout.open = true
		try(SMTD_PassDependencies.updatePassDisplay())catch()
	)
	,
	fn StoreCustomNetworkData passIndexArray =
	(
		if RPMDataNet.CustomSubmitStruct.DebugPrint == true do
			print ("{info} StoreCustomNetworkData called ")
		if SMTDSettings_copy == undefined do return();
		if not rpmdata.isCurrentRollout #CustomSubmit do return();

		--print #(passIndexArray)
		-- just set all to the same thing for now
		if passIndexArray.count == 1 then
		(
			for j in passIndexArray do
				StoreAllDeadline6Data j;
		) else (
			-- figure out which property has changed:
			local propertyNames = #()
			local propertyValues  = #()
			local dlProps = getpropnames SMTDSettings;
			for i in dlProps do
			(
				if (getproperty SMTDSettings i) as string != (getproperty SMTDSettings_copy i) as string do
				(
					append propertyNames i
					append propertyValues (getproperty SMTDSettings i)
				)
			)
--print #(propertyNames)
--print #(propertyValues)
			-- then update all
			if propertyNames.count > 0 do
				for j in passIndexArray do
					UpdateDeadline6Data j propertyNames propertyValues
		)
	)
	,
		fn RPMloadDeadlineSettings indexOverride: =
		(
			print "RPM based load deadline default settings called"
			--return(print "SKIPPING LOADING OF DEADLINE DATA")
			passIndex = 1
			
			if indexOverride != unsupplied do 
				passIndex = indexOverride
				
			-- first we get the current settings 
			shared_slaves_count = SMTDSettings.Slaves.count
			shared_slaves = SMTDSettings.Slaves
			shared_pools_list = SMTDSettings.Pools
			shared_groups_list = SMTDSettings.Groups
			try(shared_networkroot = SMTDPaths.NetworkRoot)catch()
			try(
				--dlProps = getpropnames SMTDSettings
				local numb = rpmdata.rmgetstordata passIndex
				--try(
					cPassData = execute (getappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb)
				--)catch(print ("Deadline data failed to restore:" + getCurrentException()); return false)
				for i in cPassData do
				(
					if isproperty SMTDSettings  i[1] do
						setproperty SMTDSettings i[1] i[2]
				)

				SMTDSettings_copy = copy SMTDSettings
			) catch(
				StoreAllDeadline6Data passIndex
				--dlProps = getpropnames SMTDSettings
				local numb = rpmdata.rmgetstordata passIndex
				try(
					cPassData = execute (getappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb)
				)catch(print ("Deadline data failed to restore:" + getCurrentException()); return false)
				for i in cPassData do
				(
					if isproperty SMTDSettings  i[1] do
						setproperty SMTDSettings i[1] i[2]
				)

				SMTDSettings_copy = copy SMTDSettings
			)
			SMTDSettings.Slaves.count = shared_slaves_count 
			SMTDSettings.Slaves = shared_slaves
			SMTDSettings.Pools = shared_pools_list
			SMTDSettings.Groups = shared_groups_list
			try( SMTDPaths.NetworkRoot = shared_networkroot )catch()
			SMTDSettings_copy = copy SMTDSettings
			
			
			-- now the load function from deadline:
			-- I don't call the function from the deadline calls as it breaks the data - just a small mod, merge and then swap back to calling this:
			--SMTDFunctions.loadSettings();
			
			SMTDFunctions.GetNetworkPath()
			local theSettingsList = SMTDFunctions.getSettingsList()
			
			for i in theSettingsList where i[3] != #none do
			(
				theDefault = getProperty SMTDSettings i[3]
				theValue = SMTDFunctions.getInI i[1] i[2] theDefault executeIt:i[4] useStickyFile:(not (i[7]==false)) isSticky:(not (i[8]==false))
					
					
				if findItem #("RegionRenderingMode") i[2] > 0 do
				(
					if findItem #("none", "singleframemultiregion", "animationmultiregion", "singleframetiles", "animationtiles", "maxregion") (tolower (theValue as string)) == 0 do theValue = "none"
					theValue = theValue as name	
				)
				if findItem #("SubmitSceneMode") i[2] > 0 do 
				(
					if 	theValue == "" do theValue == "reposave"
					theValue = theValue as name
				)

				if theValue != "" as name do
					setProperty SMTDSettings i[3] theValue
			)
			
			if SMTDSettings.JobName == "" or SMTDSettings.AutomaticallyUpdateJobName then
			(
				if getfilenamefile maxfilename != "" then
					SMTDSettings.JobName = getfilenamefile maxfilename
				else
					SMTDSettings.JobName = "Untitled 3ds Max Job"
			)
				
			if SMTDSettings.OutOfOrderMethod == "" then
				SMTDSettings.OutOfOrderMethod = #normal
			else	
				SMTDSettings.OutOfOrderMethod = SMTDSettings.OutOfOrderMethod as name		

			if not SMTDSettings.MaxVersionToForceSticky then
				if is64bitApplication() then
					SMTDSettings.MaxVersionToForce = "64bit"
				else
					SMTDSettings.MaxVersionToForce = "32bit"

			rendererID = SMTDFunctions.getRendererIdString()
			
			if (SMTDFunctions.getInI "RenderingOptions" "ForceRestartRenderer" true useStickyFile:false isSticky:false) do
			(
				if rendererID == "mentalray" or rendererID == "brazil" or rendererID == "vray" or rendererID == "brmax" then
					SMTDSettings.RestartRenderer = true 
			)
			
			if SMTDSettings.OutputFilenameUserPattern != "" do SMTDSettings.ReplaceOutputFilenameWithUserPattern = true
				
			SMTDSettings.LimitGroups = for i in SMTDSettings.LimitGroups where i != "" collect i --clear empty names
			SMTDSettings.LimitGroupsToUse = for i in SMTDSettings.LimitGroupsToUse where i != "" collect i --clear empty names
				
			if not SMTDSettings.SlaveSettingsSticky then --if settings are sticky, load the last settings
			(
				setIniSetting SMTDPaths.InIFile "Blacklist"  "SlavesNamedSet"  SMTDSettings.SlavesNamedSet 
				setIniSetting SMTDPaths.InIFile "Blacklist"  "BlackOrWhite" (SMTDSettings.SlavesBlackList as string) 
				setIniSetting SMTDPaths.InIFile "Blacklist"  "SlavesList" "#()" 
			)		

			--SHOTGUN (loading from persistent globals)
			if pg_SGDraftTemplate != undefined then
				SMTDSettings.SGDraftTemplate = pg_SGDraftTemplate
				
			if pg_SGVersion != undefined then
				SMTDSettings.SGVersion= pg_SGVersion
				
			if pg_SGDescription != undefined then
				SMTDSettings.SGDescription = pg_SGDescription
				
			if pg_SGTask != undefined then
				SMTDSettings.SGTask = pg_SGTask
			
			if pg_SGEntity != undefined then
				SMTDSettings.SGEntity = pg_SGEntity
			
			if pg_SGUser != undefined then
				SMTDSettings.SGUser = pg_SGUser
			
			if pg_SGProject != undefined then
				SMTDSettings.SGProject = pg_SGProject
			
			if pg_SGDisplayInfo != undefined then
				SMTDSettings.SGDisplayInfo = pg_SGDisplayInfo
			
			if pg_SGJobSettings != undefined then
				SMTDSettings.SGJobSettings = pg_SGJobSettings
                
            if pg_SGCreateMovie != undefined then
				SMTDSettings.SGCreateMovie = pg_SGCreateMovie
            
            if pg_SGCreateFilmStrip != undefined then
				SMTDSettings.SGCreateFilmStrip = pg_SGCreateFilmStrip

			--FTrack (loading from persistent globals)
			if pg_FTDescription != undefined then
				SMTDSettings.FTDescription = pg_FTDescription
				
			if pg_FTTask != undefined then
				SMTDSettings.FTTask = pg_FTTask
			
			if pg_FTAsset != undefined then
				SMTDSettings.FTAsset = pg_FTAsset
			
			if pg_FTUser != undefined then
				SMTDSettings.FTUser = pg_FTUser
			
			if pg_FTProject != undefined then
				SMTDSettings.FTProject = pg_FTProject
			
			if pg_FTDisplayInfo != undefined then
				SMTDSettings.FTDisplayInfo = pg_FTDisplayInfo
			
			if pg_FTJobSettings != undefined then
				SMTDSettings.FTJobSettings = pg_FTJobSettings			
			
			-- the store the data back into the pass	
			/*cPassData = #()
			dlProps = getpropnames SMTDSettings
			for i in 1 to dlprops.count do
			(
				val = getproperty SMTDSettings dlProps[i]
				if classof val == string then
					if findstring val "\\" != undefined do
					(
						val = rpmdata.rmconvertpathdividers val
					)
				else if classof val == array then
				(
					val = rpmdata.buildappdata val
				)
				else if classof val == dotNetObject do
				(
					continue -- we don't support these as per pass settings...
				)
				append cPassData #(dlProps[i], val)
			)*/
			--setappdata TrackViewNodes.RenderPassManager.RenderManager_BGMaps numb (RPMdata.buildappdata cPassData)
			RPMDataNet.CustomSubmitStruct.StoreAllDeadline6Data passIndex
				
		)
) -- end struct
RPMDataNet.CustomSubmitStruct = RPMDeadline6DataStruct(); -- plug the struct into an RPM variable holder for easy access
/*-----------------------------------------------------------------------------------------*/
-- define the rollouts. Pulled out of the attribute to fix stability
( --make local scope

	--local loadPath = getINISetting (scriptsPath + "RPManager/RenderPassManager.ini") "CustomSubmission" "ScriptPath"
	--filein (getfilenamepath loadPath +  "supportFiles\\initialiseDeadlineScripts.ms")
	--filein (getfilenamepath loadPath +  "SubmitMaxToDeadline_modified.ms")
	
	global SMTD_TilesRendering
	global SMTD_RegionRendering
	global SMTD_StartupDialog_Rollout 
	try(destroyDialog SMTD_StartupDialog_Rollout )catch()
	local fullSuccess = false
	local messageTitle = "SMTD 9 for RPM"
	local goOn = true

	local deadlinePath = systemTools.getEnvVariable( "DEADLINE_PATH" )

	if deadlinePath == undefined do
	(
		messagebox "The system environment variable DEADLINE_PATH is not defined on this computer. Please re-run Deadline client installer or set it manually." title:messageTitle
		goOn = false
	)
	
	local VersionInfo = dotnetclass "System.Diagnostics.FileVersionInfo"
	local MyMax = VersionInfo.GetVersionInfo (pathConfig.appendPath (pathConfig.GetDir #maxroot) "3dsmax.exe")
	try(
		--format "%\n" ( "3dsMax, API, SDK version: " + (maxversion() as string) )
		--format "%\n" ( "3dsmax.exe version: " + (MyMax.FileVersion as string) )
		if findItem #("14.0.0.121","14.6.0.388","15.0.0.347","15.1.348.0","16.4.265.0") (MyMax.FileVersion as string) > 0 do 
		(
			messagebox ("A version of 3ds Max ("+ (MyMax.FileVersion as string) +") that is known to be incompatible with SMTD has been detected!\n\nPlease UPDATE 3ds Max to the latest Product Update (PU/SP), then try launching SMTD again!") title:messageTitle 
			goOn = false
		)
	)
	catch
	(
		format "--FAILED to Confirm 3dsMax.exe Version.\n"
	)

	rollout SMTD_StartupDialog_Rollout "SMTD 9 for RPM Loading..."
	(
		progressbar prg_loading color:green height:20 width:280
		label lbl_progress "Startup..."
	)

	if goOn then
	(
		createDialog SMTD_StartupDialog_Rollout 300 50
		
		SMTD_StartupDialog_Rollout.prg_loading.value = 15.0
		SMTD_StartupDialog_Rollout.lbl_progress.text = "Looking for Network Root..."
		local theNetworkRoot = ""
		
		-- call DeadlineCommand to find the network root (assume it is in the path)
		try
		(
			local result = -2
				
			local submitOutputFile = sysInfo.tempdir + "submitOutput.txt"
			local submitExitCodeFile = sysInfo.tempdir + "submitExitCode.txt"
			
			deleteFile submitOutputFile
			deleteFile submitExitCodeFile
					
			local commandArguments = "-outputfiles \"" + submitOutputFile + "\" \"" + submitExitCodeFile + "\" -getrepositorypath"
			local deadlineCommandBG = deadlinePath + "\\deadlinecommandbg.exe"
			ShellLaunch deadlineCommandBG commandArguments
					
			local startTimeStamp = timestamp()
			local ready = false
			while not ready do
			(
				sleep 0.15
				if doesFileExist submitExitCodeFile do
				(
					local theFile = openFile submitExitCodeFile
					try(result = readValue theFile)catch(result = -2)
					try(close theFile)catch()
					ready = true
				)	
				if timestamp() - startTimeStamp > 10000 then 
				(
					result = -3
					ready = true
				)	
			)
			
			if( result == 0 ) then
			(
				local resultFile = OpenFile submitOutputFile
				local resultMsg = ""
				if (resultFile != undefined) do
				(
					try(resultMsg = readLine resultFile)catch()
					try(close resultFile)catch()
				)
				
				theNetworkRoot = resultMsg
			)
			else
			(
				if result == -3 then
					messageBox "Timed out getting Repository Root from Deadline Command.\nError code: 1001" title:messageTitle
				else
					messageBox "Failed to get Repository Root from Deadline Command.\nError code: 1002" title:messageTitle
					
			)
		)
		catch
			messageBox "Error calling Deadline Command to get Repository Root.\nError code: 1003" title:messageTitle

		--local loadPath = getfilenamepath (getINISetting (scriptsPath + "RPManager/RenderPassManager.ini") "CustomSubmission" "ScriptPath") + "supportFiles\\"
		local loadPath = theNetworkRoot +"\\submission\\3dsmax\\Main\\"
		
		
		fn getFileInfoDotNet theFileName =
		(
			local fileLookup = dotnetobject "System.IO.DirectoryInfo" (getFileNamePath theFileName)
			local allMatchingFiles = #()
			try (
				allMatchingFiles = fileLookup.getFiles (filenamefrompath theFileName) 
			) catch()
			if allMatchingFiles.count == 1 then
			(
				local dotNetFile = allMatchingFiles[1]
				local fname = dotNetFile.FullName
				local date_ = dotNetFile.lastWriteTime.ToString()
				local size_ = dotNetFile.length
				#(fname, date_, size_)
			)
			else
				#()
		)	
		local theFilesToLoad = #(
			--#(1: File Name, 2: Base Error Code, 3: target folder, 4: fatal error, 5:autoload off if file was missing  6:load this file  7:force loading even if file was local )
			#("RegionManipulator.ms", 1040, #userStartupScripts,false,false,true),
			#("TileManipulator.ms", 1042, #userStartupScripts,false,false,true),
			#("SubmitMaxToDeadline_Functions.ms", 1004, #userScripts, true,false,true,true),
			#("SubmitMaxToDeadline_SanityCheck_Private.ms", 1024, #userScripts,false,true,true, true),
			#("SubmitMaxToDeadline_SanityCheck_General.ms", 1020, #userScripts,false,true,true, true),
			#("SubmitMaxToDeadline_SanityCheck.ms", 1022, #userScripts,false,false,true),
			#("SubmitMaxToDeadline.ms", 1030, #userScripts,true,false,false, true),
			#("SubmitMaxToDeadline_Defaults.ini", 1101, #userScripts,false,false,false),
			#("SubmitMaxToDeadline_StickySettings.ini", 1102, #userScripts,false,false,false),
			#("SubmitMaxToDeadline_Functions.ms", 1004, #userScripts, true,false,true,true) -- again
		)
		local goOn = true
		for i = 1 to theFilesToLoad.count do
		(
			local st = timestamp()
			SMTD_StartupDialog_Rollout.prg_loading.value = 10 + (90.0*i/theFilesToLoad.count)
			SMTD_StartupDialog_Rollout.lbl_progress.text = "Loading File [" + theFilesToLoad[i][1] + "]"
			try( 
				local theScript = theNetworkRoot + "\\submission\\3dsmax\\Main\\" + theFilesToLoad[i][1]
				local theTarget = (GetDir theFilesToLoad[i][3] + "\\" + theFilesToLoad[i][1])
				if doesFileExist theScript then
				(
					local theInfo1 = getFileInfoDotNet theScript
					local theInfo2 = #("","","")
					if doesFileExist theTarget do
						theInfo2 = getFileInfoDotNet theTarget
					--format "Info1 = %\n" theInfo1
					--format "Info2 = %\n" theInfo2

					if theInfo1[2] != theInfo2[2] or theInfo1[3] != theInfo2[3] then
					(
						print ("Deadline support file changed on network, overwriting local versions:" + theFilesToLoad[i][1])
						deleteFile theTarget
						copyFile theScript theTarget
						if theFilesToLoad[i][6] == true do fileIn theTarget quiet:true		
						if theFilesToLoad[i][5] == true do SMTD_AutoLoadSuccessful = false
					)
					else
					(
						if theFilesToLoad[i][7] == true then 
							fileIn theTarget quiet:true
						--else if not localLauncherExists or SMTD_AutoLoadSuccessful != true do 
						--	if theFilesToLoad[i][6] == true do fileIn theTarget quiet:true
					)
				)	
				else
				(
					messageBox ("Failed To Find the file ["+theFilesToLoad[i][1]+"] in Deadline Repository. (error code: "+ theFilesToLoad[i][2] as string  +")") title:messageTitle
					if theFilesToLoad[i][4] == true do
					(
						local goOn = false
						exit
					)				
				)
			)
			catch
			(
				messageBox ("Failed To Load the file ["+theFilesToLoad[i][1]+"] from Deadline Repository. (error code: "+(theFilesToLoad[i][2]+1) as string+")") title:messageTitle
				if theFilesToLoad[i][4] == true do
				(
					local goOn = false
					exit
				)			
			)
			format "Loading %: %ms\n" theFilesToLoad[i][1] (timestamp()-st)
		)	
		/*local theFilesToLoad = #(
			--#(1: File Name, 2: Base Error Code, 3: target folder, 4: fatal error)
			#("RegionManipulator.ms", 1040, #userStartupScripts,false,false,true),
			#("TileManipulator.ms", 1042, #userStartupScripts,false,false,true),
			#("SubmitMaxToDeadline_Functions.ms", 1004, #userScripts, true,false,true),
			#("SubmitMaxToDeadline_SanityCheck_Private.ms", 1024, #userScripts,false,true,true),
			#("SubmitMaxToDeadline_SanityCheck_General.ms", 1020, #userScripts,false,true,true),
			#("SubmitMaxToDeadline_SanityCheck.ms", 1022, #userScripts,false,false,true),
			#("SubmitMaxToDeadline.ms", 1030, #userScripts,true,false,false),
			#("SubmitMaxToDeadline_Functions.ms", 1004, #userScripts, true,false,true)
		)
		
		local goOn = true
		for i = 1 to theFilesToLoad.count do
		(
			local st = timestamp()
			SMTD_StartupDialog_Rollout.prg_loading.value = 10 + (90.0*i/theFilesToLoad.count)
			SMTD_StartupDialog_Rollout.lbl_progress.text = "Loading File [" + theFilesToLoad[i][1] + "]"
			try( 
				local theScript = theNetworkRoot + "\\submission\\3dsmax\\Main\\" + theFilesToLoad[i][1]
				local theTarget = (GetDir theFilesToLoad[i][3] + "\\" + theFilesToLoad[i][1])
	            format "Running the script \"%\"\n" theScript
				if doesFileExist theScript then
				(
					local theInfo1 = getFileInfoDotNet theScript
					local theInfo2 = #("","","")
					if doesFileExist theTarget do
						theInfo2 = getFileInfoDotNet theTarget
					--format "Info1 = %\n" theInfo1
					--format "Info2 = %\n" theInfo2
					
					if theInfo1[2] != theInfo2[2] or theInfo1[3] != theInfo2[3] then
					(
						deleteFile theTarget
						copyFile theScript theTarget
						fileIn theTarget quiet:true		
					)
					else
					(
						fileIn theTarget quiet:true	
					)
				)	
				else
				(
					SMTD_StartupDialog_Rollout.prg_loading.color = red
					messageBox ("Failed To Find ["+(filenameFromPath theScript)+"] in \n"+(getFileNamePath theScript)+"\nError code: "+ theFilesToLoad[i][2] as string  +")") title:messageTitle
					if theFilesToLoad[i][4] == true do
					(
						local goOn = false
						exit
					)				
				)
			)
			catch
			(
				SMTD_StartupDialog_Rollout.prg_loading.color = red
				messageBox ("ERROR LOADING ["+(filenameFromPath theScript)+"] from \n"+(getFileNamePath theScript)+"\nError code: "+(theFilesToLoad[i][2]+1) as string+")") title:messageTitle
				if theFilesToLoad[i][4] == true do
				(
					local goOn = false
					exit
				)			
			)
			format "Loading %: %ms\n" theFilesToLoad[i][1] (timestamp()-st)
		)	
		*/
		SMTD_StartupDialog_Rollout.prg_loading.value = 100.0
		try(destroyDialog SMTD_StartupDialog_Rollout )catch()
		-- set this to access the menu from RPM:
		try(
			-- this is for RPM 6.045+ where a  menu item  has been added to access custom menus (in the XData menu)
			RPMDataNet.CustomSubmitRCMenu = SMTD_MainRollout_MainMenu;
		)catch()
	)
) --end rollout creation
